package ;

import neko.net.ThreadRemotingServer;
import haxe.remoting.SocketConnection;
import haxe.remoting.Context;

class NekoServer extends ThreadRemotingServer {
	public static var users = new List< ClientData >();
	public static var count : Int = 0;

	public function new() {
		super();
		var host = "localhost";
		var port = 4040;
		neko.Lib.println("Running server on " + host + ":" + port);
		run( host, port );
	}

	static var ns:NekoServer;
	static var ps:PolicyServer;
	public static function main() 
	{
		neko.vm.Thread.create(function() ps = new PolicyServer("localhost"));
		ns = new NekoServer();	
	}

	override function initClientApi( cnx : SocketConnection, server : Context ) {
		neko.Lib.println( "Client " + (++count) + " connected." );
		var user = new ClientData( cnx, count );
		server.addObject( "ClientData", user );
		users.add( user );
		( cast cnx ).__user = user;
	}
	
	override function clientDisconnected( c : SocketConnection ) {
		neko.Lib.println( "Client Disconnected : id = " + ( cast c ).__user.id );
		var user : ClientData = ( cast c ).__user;
		users.remove( user );
		for ( u in users )
			if ( u.id != user.id )
				u.removeUser( user.id );
	}
}